﻿using Model.Dto;
using Prism.Commands;
using Prism.Mvvm;
using Prism.Services.Dialogs;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace PLCTool.ViewModels.BusinessManageViewModel
{
    public class WritePLCViewModel : BindableBase, IDialogAware
    {
        public WritePLCViewModel()
        {
            SureCommand = new DelegateCommand<object>(Sure);
            CancelCommand = new DelegateCommand<object>(Cancel);
            CloseCommand = new DelegateCommand<object>(CloseMethod);
        }

        private void CloseMethod(object obj)
        {
            RequestClose?.Invoke(new DialogResult(ButtonResult.Cancel));
        }

        private void Sure(object obj)
        {
            if(string.IsNullOrEmpty(PLCAddr)|| string.IsNullOrEmpty(PLCValue))
            {
                MessageBox.Show("请填写PLC地址和数值", "确认", MessageBoxButton.OK, MessageBoxImage.Information);
                return;
            }
            DialogParameters parm = new DialogParameters();
            parm.Add("ReturnValue", PLCValue);
            RequestClose?.Invoke(new DialogResult(ButtonResult.OK, parm));
        
        }

        public string Title { set; get; } = "PLC写入";

        public event Action<IDialogResult> RequestClose;

        public bool CanCloseDialog()
        {
            return true;
        }

        public void OnDialogClosed()
        {
     
        }
        private void Cancel(object obj)
        {
            RequestClose?.Invoke(new DialogResult(ButtonResult.Cancel));
        }
        public void OnDialogOpened(IDialogParameters parameters)
        {
           
            var getPlcAddr = parameters.GetValues<string>("Key");
            ///值不为空，表示修改
            if (getPlcAddr != null)
            {
                foreach (var item in getPlcAddr)
                {
                    PLCAddr=item;
                }
            }
            var getPlcValue = parameters.GetValues<string>("Key2");
            ///值不为空，表示修改
            if (getPlcValue != null)
            {
                foreach (var item in getPlcValue)
                {
                    PLCValue = item;
                }
            }
        }

        #region MyRegion
        /// <summary>
        /// plc 地址
        /// </summary>
        private string plcAddr;
        public string PLCAddr
        {
            get { return plcAddr; }
            set { plcAddr = value; RaisePropertyChanged(); }
        }
        /// <summary>
        /// plc 数据
        /// </summary>
        private string plcValue;
        public string PLCValue
        {
            get { return plcValue; }
            set { plcValue = value; RaisePropertyChanged(); }
        }


        #endregion

        #region 命令绑定
        public DelegateCommand<object> CloseCommand { set; get; }
        public DelegateCommand<object> SureCommand { set; get; }
        public DelegateCommand<object> CancelCommand { set; get; }
        #endregion
    }
}
